package main

import (
	"fmt"
	"os"
	"io"
	"strings"
)





//receives a filename and returns a string array; strips newline at the end
func fileToStringArray(filename string) []string {
	file, err := os.Open(filename)
	if err != nil {
		fmt.Fprintf(os.Stderr, "error: %v\n", err)
        os.Exit(1)
	}



	// Read the entire file and print to the standard output
	b, err := io.ReadAll(file)
	if err != nil {
		fmt.Fprintf(os.Stderr, "error: %v\n", err)
        os.Exit(1)
	}

	file.Close()

	tmp := strings.TrimRight(string(b), "\n")
	return strings.Split(tmp, "\n")

}


//returns true if the given path/file is a directory
func isDir(filename string) bool {
	file, err := os.Open(filename)
	if err != nil {
		fmt.Fprintf(os.Stderr, "error: %v\n", err)
        os.Exit(1)
	}
	// This returns an *os.FileInfo type
	fileInfo, err := file.Stat()
	if err != nil {
		fmt.Fprintf(os.Stderr, "error: %v\n", err)
        os.Exit(1)
	}

	return fileInfo.IsDir()
}