package main

import (
	"flag"
	_ "fmt"
	"os"
	"strconv"
)

type arrayFlags []string

func (i *arrayFlags) String() string {
	return "my string representation"
}

func (i *arrayFlags) Set(value string) error {
	*i = append(*i, value)
	return nil
}

//var cmp string

func menu() {
    inputFilePtr := flag.String("source", "", "Input signature file; either compares all entries against itself or against 'destination'")
    destFilePtr  := flag.String("destination", "", "Destination signature file; compared against 'source'")
    inputPtr 	 := flag.String("in", "", "[dir|file], generates signatures of the txt file / of all txt-files in dir and prints them to stdio")
    thresholdPtr := flag.String("T", "0.0", "Sets the Threshold also named significance which is by default 0.42 (0.0 <= t <= 1.0); setting it to 0.0 will print all matches, setting it to 1.0 only exact matches")
    cmpPtr 		 := flag.Bool("cmp", false, "[FILE1 FILE2] which will be compared against each other; must be the last option/flag") 
    regLDPtr     := flag.String("regLD", "", "[Folder] Does and all-against-all comparison applying the regular LD")
      
    flag.Parse()

  

    //prints help menu if no option is set
    if len(os.Args) == 1{
    	flag.PrintDefaults()
        os.Exit(1)
    }

    //set threshold 
    T, _ := strconv.ParseFloat(*thresholdPtr, 64)
    _ = T

    //if input dir is set  and maybe destination
    if *inputFilePtr != "" {
        if *destFilePtr != "" {
        	//fmt.Println("compare two csv:", *inputFilePtr, *destFilePtr)
        	compare_two_csv(*inputFilePtr, *destFilePtr, T)
        } else {
        	//fmt.Println("compare one csv:", *inputFilePtr)
        	compare_one_csv(*inputFilePtr, T)
        }
    }


    //process file or all files in dir, generate signatures and print them
    if *inputPtr != "" {
    	//fmt.Println("process dir:", *inputPtr)
    	processDirOrFile(*inputPtr)
    }

    if *cmpPtr {
    	//fmt.Println("compare two files", os.Args[2], os.Args[3])
        //fmt.Println("foobar", len(os.Args))
        compareTwoFiles(os.Args[len(os.Args)-2], os.Args[len(os.Args)-1])
    }

    if *regLDPtr != "" {
        processDirForRegLD(*regLDPtr)
    }
}
